// The sample contained herein is provided to you "AS IS".
//
// It is furnished by Add-in Express as a simple example and has not been
// thoroughly tested under all conditions. Add-in Express, therefore, cannot
// guarantee its reliability, serviceability or functionality.

unit OutlookPaneEventsD7_IMPL;

interface

uses
  SysUtils, ComObj, ComServ, ActiveX, Variants, Outlook2000, Office2000, adxAddIn, OutlookPaneEventsD7_TLB, StdVcl,
  Classes, adxolFormsManager, Unit1, Unit2, uUtils;

type
  TCoOutlookPaneEventsD7 = class(TadxAddin, ICoOutlookPaneEventsD7)
  end;

  TAddInModule = class(TadxCOMAddInModule)
    adxOlFormsManager1: TadxOlFormsManager;
    procedure adxOlFormsManager1Initialize(ASender: TObject);
    procedure adxOlFormsManager1Error(ASender: TObject;
      Args: TadxOlErrorEventArgs);
    procedure adxOlFormsManager1ADXNavigationPaneHide(ASender: TObject;
      Args: TadxOlNavigationPaneHideEventArgs);
    procedure adxOlFormsManager1ADXNavigationPaneMinimize(ASender: TObject;
      Args: TadxOlNavigationPaneMinimizeEventArgs);
    procedure adxOlFormsManager1ADXNavigationPaneShow(ASender: TObject;
      Args: TadxOlNavigationPaneShowEventArgs);
    procedure adxOlFormsManager1ADXReadingPaneHide(ASender: TObject;
      Args: TadxOlReadingPaneHideEventArgs);
    procedure adxOlFormsManager1ADXReadingPaneMove(ASender: TObject;
      Args: TadxOlReadingPaneMoveEventArgs);
    procedure adxOlFormsManager1ADXReadingPaneShow(ASender: TObject;
      Args: TadxOlReadingPaneShowEventArgs);
    procedure adxOlFormsManager1ADXTodoBarHide(ASender: TObject;
      Args: TadxOlTodoBarHideEventArgs);
    procedure adxOlFormsManager1ADXTodoBarMinimize(ASender: TObject;
      Args: TadxOlTodoBarMinimizeEventArgs);
    procedure adxOlFormsManager1ADXTodoBarShow(ASender: TObject;
      Args: TadxOlTodoBarShowEventArgs);
  private
    function GetEventForm: TEventForm; 
  protected
  public
  end;

implementation



{$R *.dfm}

procedure TAddInModule.adxOlFormsManager1Initialize(ASender: TObject);
begin
  OutlookUtils.InitOutlookVersion(self.OutlookApp.DefaultInterface);
end;

procedure TAddInModule.adxOlFormsManager1Error(ASender: TObject;
  Args: TadxOlErrorEventArgs);
begin
  Args.Handled := true;
  Common.ShowError(Strings.FormsManagerOnError + #13#10 + Args.E.Message);
end;

function TAddInModule.GetEventForm: TEventForm;
begin
  if (adxOlFormsManager1.Items[0].FormInstanceCount > 0) then begin
    result := adxOlFormsManager1.Items[0].FormInstances[0] as TEventForm;
  end
  else begin
    result := nil;
  end;
end;

procedure TAddInModule.adxOlFormsManager1ADXNavigationPaneHide(
  ASender: TObject; Args: TadxOlNavigationPaneHideEventArgs);
begin
  if (GetEventForm() <> nil) then begin
   if (Args.OutlookBar) then begin
     GetEventForm().AddEvent('ADXNavigationPaneHide.OutlookBar');
   end
   else begin
     case (OutlookUtils.OutlookVersion) of
       v2000,
       v2002:
         GetEventForm().AddEvent('ADXNavigationPaneHide.FolderList');

       v2003,
       v2007:
         GetEventForm().AddEvent('ADXNavigationPaneHide');
     end;
   end;
  end;
end;

procedure TAddInModule.adxOlFormsManager1ADXNavigationPaneMinimize(
  ASender: TObject; Args: TadxOlNavigationPaneMinimizeEventArgs);
begin
  if (GetEventForm() <> nil) then begin
    GetEventForm().AddEvent('ADXNavigationPaneMinimize');
  end;
end;

procedure TAddInModule.adxOlFormsManager1ADXNavigationPaneShow(
  ASender: TObject; Args: TadxOlNavigationPaneShowEventArgs);
begin
  if (GetEventForm() <> nil) then begin
   if (Args.OutlookBar) then begin
     GetEventForm().AddEvent('ADXNavigationPaneShow.OutlookBar');
   end
   else begin
     case (OutlookUtils.OutlookVersion) of
       v2000,
       v2002:
         GetEventForm().AddEvent('ADXNavigationPaneShow.FolderList');

       v2003,
       v2007:
         GetEventForm().AddEvent('ADXNavigationPaneShow');
     end;
   end;
  end;
end;

procedure TAddInModule.adxOlFormsManager1ADXReadingPaneHide(
  ASender: TObject; Args: TadxOlReadingPaneHideEventArgs);
begin
  if (GetEventForm() <> nil) then begin
    case (OutlookUtils.OutlookVersion) of
      v2000,
      v2002:
        GetEventForm().AddEvent('ADXReadingPaneHide.PreviewPane');
      v2003,
      v2007:
        GetEventForm().AddEvent('ADXReadingPaneHide');
    end;
  end;
end;

procedure TAddInModule.adxOlFormsManager1ADXReadingPaneMove(
  ASender: TObject; Args: TadxOlReadingPaneMoveEventArgs);
begin
  if (GetEventForm() <> nil) then begin
    case (OutlookUtils.OutlookVersion) of
      v2000,
      v2002:
        GetEventForm().AddEvent('ADXReadingPaneMove.PreviewPane');
      v2003,
      v2007:
        GetEventForm().AddEvent('ADXReadingPaneMove');
    end;
  end;
end;

procedure TAddInModule.adxOlFormsManager1ADXReadingPaneShow(
  ASender: TObject; Args: TadxOlReadingPaneShowEventArgs);
begin
  if (GetEventForm() <> nil) then begin
    case (OutlookUtils.OutlookVersion) of
      v2000,
      v2002:
        GetEventForm().AddEvent('ADXReadingPaneShow.PreviewPane');
      v2003,
      v2007:
        GetEventForm().AddEvent('ADXReadingPaneShow');
    end;
  end;
end;

procedure TAddInModule.adxOlFormsManager1ADXTodoBarHide(ASender: TObject;
  Args: TadxOlTodoBarHideEventArgs);
begin
  if (GetEventForm() <> nil) then begin
    GetEventForm().AddEvent('ADXTodoBarHide');
  end;
end;

procedure TAddInModule.adxOlFormsManager1ADXTodoBarMinimize(
  ASender: TObject; Args: TadxOlTodoBarMinimizeEventArgs);
begin
  if (GetEventForm() <> nil) then begin
    GetEventForm().AddEvent('ADXTodoBarMinimize');
  end;
end;

procedure TAddInModule.adxOlFormsManager1ADXTodoBarShow(ASender: TObject;
  Args: TadxOlTodoBarShowEventArgs);
begin
  if (GetEventForm() <> nil) then begin
    GetEventForm().AddEvent('ADXTodoBarShow');
  end;
end;

initialization
  TadxFactory.Create(ComServer, TCoOutlookPaneEventsD7, CLASS_CoOutlookPaneEventsD7, TAddInModule);

end.
